from pycircuit.device import *
from pycircuit.footprint import *



### FT232
Device('FT2232H',
       # Power and ground
       Pin('VCORE'), # 1V8
       Pin('VCCIO'), # 3V3
       Pin('VPLL'), # 3V3
       Pin('VPHY'), # 3V3
       Pin('VREGIN'),
       Pin('VREGOUT'),
       Pin('AGND'),
       Pin('GND'),
       # Common pins
       Pin('OSCI', Bus('XTAL', 'XI')), # 12MHz
       Pin('OSCO', Bus('XTAL', 'XO')), # 12MHz
       Pin('REF'),
       Pin('DM', Bus('USB', 'D-')),
       Pin('DP', Bus('USB', 'D+')),
       Pin('TEST'),
       Pin('RESET'),
       Pin('PWREN'),
       Pin('SUSPEND'),
       # EEPROM
       Pin('EECS'),
       Pin('EECLK'),
       Pin('EEDATA'),
       # Channel A
       Pin('ADBUS0', Bus('UART0', 'UART', 'TX'),
           Bus('JTAG0', 'JTAG', 'TCK'), Bus('SPI0', 'SPI', 'SCK')),
       Pin('ADBUS1', Bus('UART0', 'UART', 'RX'),
           Bus('JTAG0', 'JTAG', 'TDI'), Bus('SPI0', 'SPI', 'MISO')),
       Pin('ADBUS2', Bus('JTAG0', 'JTAG', 'TDO'),
           Bus('SPI0', 'SPI', 'MOSI')),
       Pin('ADBUS3', Bus('JTAG0', 'JTAG', 'TMS'),
           Bus('SPI0', 'SPI', 'SS0')),
       Pin('ADBUS4'),
       Pin('ADBUS5'),
       Pin('ADBUS6'),
       Pin('ADBUS7'),
       Pin('ACBUS0'),
       Pin('ACBUS1'),
       Pin('ACBUS2'),
       Pin('ACBUS3'),
       Pin('ACBUS4'),
       Pin('ACBUS5'),
       Pin('ACBUS6'),
       Pin('ACBUS7'),
       # Channel B
       Pin('BDBUS0', Bus('UART1', 'UART', 'TX'),
           Bus('JTAG1', 'JTAG', 'TCK'), Bus('SPI1', 'SPI', 'SCK')),
       Pin('BDBUS1', Bus('UART1', 'UART', 'RX'),
           Bus('JTAG1', 'JTAG', 'TDI'), Bus('SPI1', 'SPI', 'MISO')),
       Pin('BDBUS2', Bus('JTAG1', 'JTAG', 'TDO'),
           Bus('SPI1', 'SPI', 'MOSI')),
       Pin('BDBUS3', Bus('JTAG1', 'JTAG', 'TMS'),
           Bus('SPI1', 'SPI', 'SS0')),
       Pin('BDBUS4'),
       Pin('BDBUS5'),
       Pin('BDBUS6'),
       Pin('BDBUS7'),
       Pin('BCBUS0'),
       Pin('BCBUS1'),
       Pin('BCBUS2'),
       Pin('BCBUS3'),
       Pin('BCBUS4'),
       Pin('BCBUS5'),
       Pin('BCBUS6'),
       Pin('BCBUS7', 'PWRSAV'))



Footprint('FT2232HQ', 'FT2232H', 'QFN64',
          Map(1, 'GND'),
          Map(2, 'OSCI'),
          Map(3, 'OSCO'),
          Map(4, 'VPHY'),
          Map(5, 'GND'),
          Map(6, 'REF'),
          Map(7, 'DM'),
          Map(8, 'DP'),
          Map(9, 'VPLL'),
          Map(10, 'AGND'),
          Map(11, 'GND'),
          Map(12, 'VCORE'),
          Map(13, 'TEST'),
          Map(14, 'RESET'),
          Map(15, 'GND'),
          Map(16, 'ADBUS0'),
          Map(17, 'ADBUS1'),
          Map(18, 'ADBUS2'),
          Map(19, 'ADBUS3'),
          Map(20, 'VCCIO'),
          Map(21, 'ADBUS4'),
          Map(22, 'ADBUS5'),
          Map(23, 'ADBUS6'),
          Map(24, 'ADBUS7'),
          Map(25, 'GND'),
          Map(26, 'ACBUS0'),
          Map(27, 'ACBUS1'),
          Map(28, 'ACBUS2'),
          Map(29, 'ACBUS3'),
          Map(30, 'ACBUS4'),
          Map(31, 'VCCIO'),
          Map(32, 'ACBUS5'),
          Map(33, 'ACBUS6'),
          Map(34, 'ACBUS7'),
          Map(35, 'GND'),
          Map(36, 'SUSPEND'),
          Map(37, 'VCORE'),
          Map(38, 'BDBUS0'),
          Map(39, 'BDBUS1'),
          Map(40, 'BDBUS2'),
          Map(41, 'BDBUS3'),
          Map(42, 'VCCIO'),
          Map(43, 'BDBUS4'),
          Map(44, 'BDBUS5'),
          Map(45, 'BDBUS6'),
          Map(46, 'BDBUS7'),
          Map(47, 'GND'),
          Map(48, 'BCBUS0'),
          Map(49, 'VREGOUT'),
          Map(50, 'VREGIN'),
          Map(51, 'GND'),
          Map(52, 'BCBUS1'),
          Map(53, 'BCBUS2'),
          Map(54, 'BCBUS3'),
          Map(55, 'BCBUS4'),
          Map(56, 'VCCIO'),
          Map(57, 'BCBUS5'),
          Map(58, 'BCBUS6'),
          Map(59, 'BCBUS7'),
          Map(60, 'PWREN'),
          Map(61, 'EEDATA'),
          Map(62, 'EECLK'),
          Map(63, 'EECS'),
          Map(64, 'VCORE'))
