from pycircuit.device import *
from pycircuit.footprint import *



### iCE40 FPGA Family
Device('HX1K',
       # IO Left
       Pin('IOL_1A', Bus('DPIO1', 'DPIO', '-')),
       Pin('IOL_1B', Bus('DPIO1', 'DPIO', '+')),
       Pin('IOL_2A', Bus('DPIO2', 'DPIO', '-')),
       Pin('IOL_2B', Bus('DPIO2', 'DPIO', '+')),
       Pin('IOL_3A', Bus('DPIO3', 'DPIO', '-')),
       Pin('IOL_3B', Bus('DPIO3', 'DPIO', '+')),
       Pin('IOL_4A', Bus('DPIO4', 'DPIO', '-')),
       Pin('IOL_4B', Bus('DPIO4', 'DPIO', '+')),
       Pin('IOL_5A', Bus('DPIO5', 'DPIO', '-')),
       Pin('IOL_5B', Bus('DPIO5', 'DPIO', '+')),
       Pin('IOL_6A', Bus('DPIO6', 'DPIO', '-')),
       Pin('IOL_6B_GBIN7', Bus('DPIO6', 'DPIO', '+'), Bus('GBIN', '7')),
       Pin('IOL_7A_GBIN6', Bus('DPIO7', 'DPIO', '-'), Bus('GBIN', '6')),
       Pin('IOL_7B', Bus('DPIO7', 'DPIO', '+')),
       Pin('IOL_8A', Bus('DPIO8', 'DPIO', '-')),
       Pin('IOL_8B', Bus('DPIO8', 'DPIO', '+')),
       Pin('IOL_9A', Bus('DPIO9', 'DPIO', '-')),
       Pin('IOL_9B', Bus('DPIO9', 'DPIO', '+')),
       Pin('IOL_10A', Bus('DPIO10', 'DPIO', '-')),
       Pin('IOL_10B', Bus('DPIO10', 'DPIO', '+')),
       Pin('IOL_11A', Bus('DPIO11', 'DPIO', '-')),
       Pin('IOL_11B', Bus('DPIO11', 'DPIO', '+')),
       Pin('IOL_12A', Bus('DPIO12', 'DPIO', '-')),
       Pin('IOL_12B', Bus('DPIO12', 'DPIO', '+')),
       # PLL_VCC
       Pin('GNDPLL'),
       Pin('VCCPLL'), # 1V2

       # IO Bottom
       Pin('IOB_24', 'PIO'),
       Pin('IOB_25', 'PIO'),
       Pin('IOB_26', 'PIO'),
       Pin('IOB_27', 'PIO'),
       Pin('IOB_28', 'PIO'),
       Pin('IOB_29', 'PIO'),
       Pin('IOB_30', 'PIO'),
       Pin('IOB_31', 'PIO'),
       Pin('IOB_32', 'PIO'),
       Pin('IOB_33', 'PIO'),
       Pin('IOB_35_GBIN5', 'PIO', Bus('GBIN', '5')),
       Pin('IOB_36_GBIN4', 'PIO', Bus('GBIN', '4')),
       Pin('IOB_34', 'PIO'),
       Pin('IOB_37', 'PIO'),
       Pin('IOB_38', 'PIO'),
       Pin('IOB_39', 'PIO'),
       Pin('IOB_40', 'PIO'),
       Pin('IOB_41', 'PIO'),
       Pin('IOB_42_CBSEL0', 'PIO', Bus('CBSEL', '0')),
       Pin('IOB_43_CBSEL1', 'PIO', Bus('CBSEL', '1')),
       # CONFIG
       Pin('CDONE'),
       Pin('CRESET_B'),
       # SPI
       Pin('IOB_44_SDO', 'PIO', Bus('SPI', 'MISO')),
       Pin('IOB_45_SDI', 'PIO', Bus('SPI', 'MOSI')),
       Pin('IOB_46_SCK', 'PIO', Bus('SPI', 'SCK')),
       Pin('IOB_47_SS', 'PIO', Bus('SPI', 'SS0')),
       Pin('VCC_SPI'), # 3V3

       # IO Right
       Pin('IOR_48', 'PIO'),
       Pin('IOR_49', 'PIO'),
       Pin('IOR_50', 'PIO'),
       Pin('IOR_51', 'PIO'),
       Pin('IOR_52', 'PIO'),
       Pin('IOR_53', 'PIO'),
       Pin('IOR_54', 'PIO'),
       Pin('IOR_55', 'PIO'),
       Pin('IOR_56', 'PIO'),
       Pin('IOR_57', 'PIO'),
       Pin('IOR_58', 'PIO'),
       Pin('IOR_59', 'PIO'),
       Pin('IOR_60_GBIN3', 'PIO', Bus('GBIN', '3')),
       Pin('IOR_61_GBIN2', 'PIO', Bus('GBIN', '2')),
       Pin('IOR_62', 'PIO'),
       Pin('IOR_63', 'PIO'),
       Pin('IOR_64', 'PIO'),
       Pin('IOR_65', 'PIO'),
       Pin('IOR_66', 'PIO'),
       Pin('IOR_67', 'PIO'),
       Pin('IOR_68', 'PIO'),
       Pin('IOR_69', 'PIO'),
       Pin('IOR_70', 'PIO'),
       Pin('IOR_71', 'PIO'),
       Pin('IOR_72', 'PIO'),
       Pin('VPP_2V5'), # 2V5
       Pin('VPP_FAST'),

       # IO Top
       Pin('IOT_73', 'PIO'),
       Pin('IOT_74', 'PIO'),
       Pin('IOT_75', 'PIO'),
       Pin('IOT_76', 'PIO'),
       Pin('IOT_77', 'PIO'),
       Pin('IOT_78', 'PIO'),
       Pin('IOT_79', 'PIO'),
       Pin('IOT_80', 'PIO'),
       Pin('IOT_81', 'PIO'),
       Pin('IOT_82', 'PIO'),
       Pin('IOT_83', 'PIO'),
       Pin('IOT_84_GBIN1', 'PIO', Bus('GBIN', '1')),
       Pin('IOT_85_GBIN0', 'PIO', Bus('GBIN', '0')),
       Pin('IOT_86', 'PIO'),
       Pin('IOT_87', 'PIO'),
       Pin('IOT_88', 'PIO'),
       Pin('IOT_89', 'PIO'),
       Pin('IOT_90', 'PIO'),
       Pin('IOT_91', 'PIO'),
       Pin('IOT_92', 'PIO'),
       Pin('IOT_93', 'PIO'),
       Pin('IOT_94', 'PIO'),
       Pin('IOT_95', 'PIO'),
       Pin('IOT_96', 'PIO'),
       Pin('GND'),
       Pin('VCC'), # 1V2
       Pin('VCCIO_0'), # 3V3
       Pin('VCCIO_1'), # 3V3
       Pin('VCCIO_2'), # 3V3
       Pin('VCCIO_3')) # 3V3



Footprint('HX1K-TQFP144', 'HX1K', 'TQFP144',
          Map(1, 'IOL_1A'),
          Map(2, 'IOL_1B'),
          Map(3, 'IOL_2A'),
          Map(4, 'IOL_2B'),
          Map(5, 'GND'),
          Map(6, 'VCCIO_3'),
          Map(7, 'IOL_3A'),
          Map(8, 'IOL_3B'),
          Map(9, 'IOL_4A'),
          Map(10, 'IOL_4B'),
          Map(11, 'IOL_5A'),
          Map(12, 'IOL_5B'),
          Map(13, 'GND'),
          Map(14, 'GND'),
          Map(15, None),
          Map(16, None),
          Map(17, None),
          Map(18, None),
          Map(19, 'IOL_6A'),
          Map(20, 'IOL_6B_GBIN7'),
          Map(21, 'IOL_7A_GBIN6'),
          Map(22, 'IOL_7B'),
          Map(23, 'IOL_8A'),
          Map(24, 'IOL_8B'),
          Map(25, 'IOL_9A'),
          Map(26, 'IOL_9B'),
          Map(27, 'VCC'),
          Map(28, 'IOL_10A'),
          Map(29, 'IOL_10B'),
          Map(30, 'VCCIO_3'),
          Map(31, 'IOL_11A'),
          Map(32, 'IOL_11B'),
          Map(33, 'IOL_12A'),
          Map(34, 'IOL_12B'),
          Map(35, 'GNDPLL'),
          Map(36, 'VCCPLL'),
          Map(37, 'IOB_24'),
          Map(38, 'IOB_25'),
          Map(39, 'IOB_26'),
          Map(40, None),
          Map(41, 'IOB_27'),
          Map(42, 'IOB_28'),
          Map(43, 'IOB_29'),
          Map(44, 'IOB_30'),
          Map(45, 'IOB_31'),
          Map(46, 'VCCIO_3'),
          Map(47, 'IOB_32'),
          Map(48, 'IOB_33'),
          Map(49, 'IOB_35_GBIN5'),
          Map(50, 'IOB_36_GBIN4'),
          Map(51, 'VCC'),
          Map(52, 'IOB_34'),
          Map(53, None),
          Map(54, None),
          Map(55, None),
          Map(56, 'IOB_37'),
          Map(57, 'VCCIO_2'),
          Map(58, 'IOB_38'),
          Map(59, 'GND'),
          Map(60, 'IOB_39'),
          Map(61, 'IOB_40'),
          Map(62, 'IOB_41'),
          Map(63, 'IOB_42_CBSEL0'),
          Map(64, 'IOB_43_CBSEL1'),
          Map(65, 'CDONE'),
          Map(66, 'CRESET_B'),
          Map(67, 'IOB_44_SDO'),
          Map(68, 'IOB_45_SDI'),
          Map(69, 'GND'),
          Map(70, 'IOB_46_SCK'),
          Map(71, 'IOB_47_SS'),
          Map(72, 'VCC_SPI'),
          Map(73, 'IOR_48'),
          Map(74, 'IOR_49'),
          Map(75, 'IOR_50'),
          Map(76, 'IOR_51'),
          Map(77, None),
          Map(78, 'IOR_52'),
          Map(79, 'IOR_53'),
          Map(80, 'IOR_54'),
          Map(81, 'IOR_55'),
          Map(82, None),
          Map(83, None),
          Map(84, None),
          Map(85, None),
          Map(86, 'GND'),
          Map(87, 'IOR_56'),
          Map(88, 'IOR_57'),
          Map(89, 'VCCIO_1'),
          Map(90, 'IOR_58'),
          Map(91, 'IOR_59'),
          Map(92, 'VCC'),
          Map(93, 'IOR_60_GBIN3'),
          Map(94, 'IOR_61_GBIN2'),
          Map(95, 'IOR_62'),
          Map(96, 'IOR_63'),
          Map(97, 'IOR_64'),
          Map(98, 'IOR_65'),
          Map(99, 'IOR_66'),
          Map(100, 'VCCIO_1'),
          Map(101, 'IOR_67'),
          Map(102, 'IOR_68'),
          Map(103, 'GND'),
          Map(104, 'IOR_69'),
          Map(105, 'IOR_70'),
          Map(106, 'IOR_71'),
          Map(107, 'IOR_72'),
          Map(108, 'VPP_2V5'),
          Map(109, 'VPP_FAST'),
          Map(110, None),
          Map(111, 'VCC'),
          Map(112, 'IOT_73'),
          Map(113, 'IOT_74'),
          Map(114, 'IOT_75'),
          Map(115, 'IOT_76'),
          Map(116, 'IOT_77'),
          Map(117, 'IOT_78'),
          Map(118, 'IOT_79'),
          Map(119, 'IOT_80'),
          Map(120, 'IOT_81'),
          Map(121, 'IOT_82'),
          Map(122, 'IOT_83'),
          Map(123, 'VCCIO_0'),
          Map(124, None),
          Map(125, None),
          Map(126, None),
          Map(127, None),
          Map(128, 'IOT_84_GBIN1'),
          Map(129, 'IOT_85_GBIN0'),
          Map(None, 'IOT_86'),
          Map(130, None),
          Map(131, None),
          Map(132, 'GND'),
          Map(133, 'VCCIO_0'),
          Map(134, 'IOT_87'),
          Map(135, 'IOT_88'),
          Map(136, 'IOT_89'),
          Map(137, 'IOT_90'),
          Map(138, 'IOT_91'),
          Map(139, 'IOT_92'),
          Map(140, 'GND'),
          Map(141, 'IOT_93'),
          Map(142, 'IOT_94'),
          Map(143, 'IOT_95'),
          Map(144, 'IOT_96'))
